#ifndef FLO_SDL_H
#define FLO_SDL_H

#include <SDL/SDL.h>

#include "imagemono.h"

/***********************************************
 * Code source du cours sur le dbruitage aux quations aux drives partielles
 *
 * Auteur : HUMBERT Florent
 */
 


/* cette classe n'est pas utile pour le traitement des images,
 il m'a juste servi  visualiser les restaurations*/

class G_surface;
//class G_fenetre;

class G_couleur
{
 private: 
   Uint8 r;
   Uint8 g;
   Uint8 b;

 public:
   G_couleur();
   G_couleur(Uint8 rb, Uint8 gb, Uint8 bb);
   Uint8 LireR();
   Uint8 LireG();
   Uint8 LireB();

   void Ecrire(Uint8 rb, Uint8 gb, Uint8 bb);

   friend class G_surface;
};

class G_surface
{
 private:
  SDL_Surface* surface;
  Uint32 LireAux(int x, int y);
  void EcrireAux(int x, int y, Uint32);
 
 public:
  G_surface(int x, int y);
  ~G_surface();
  
  /*Lit la couleur d'un pixel  une certaine position*/
  G_couleur Lire(int x, int y);
  
  /*Ecrit une couleur  une certaine position*/
  void Ecrire(int x, int y, G_couleur* coul);
  
  /*Rcupre la largeur de la G_surface*/
  int Largeur();
  
  /*et sa hauteur*/
  int Hauteur(); 
  
  /*Vide l'image*/
  void Vider();

  friend class G_fenetre;
};

/*Permet les converstions entre les types*/
G_surface* ImageMono2G_surface(ImageMono* im);
G_surface* ImageMono2G_surfaceAll(ImageMono* im);


/*Classe pour permettre la visualisation en directe*/
class G_fenetre
{
  private:
   SDL_Surface* fond;
  public:
   G_fenetre(int x, int y);
   ~G_fenetre();
   void Afficher();
   void Attendre();
   void EcrireG_surface(G_surface* surface);
   void EcrireG_surfaceDec(G_surface* surface);
   void Sauver(char* lien);

};

#endif
