#ifndef DEBRUITAGE_H
#define DEBRUITAGE_H

/***********************************************
 * Code source du cours sur le dbruitage aux quations aux drives partielles
 *
 * Auteur : HUMBERT Florent
 */


/*les diffrentes fonctions de dbruitage*/

/*
  Title: Fonctions de dbruitage
*/


/*
 Function: debruitageTikhonov
  Permet une restauration par la mthode de Tikhonov

  Paramtres:
    source - l'image source (non vide)
    nbiter - le nombre d'itration  effectuer
    alpha - valeurs paramtrables
    dt - discrtisation temporelle

 Retour:
   Un pointeur sur l'image corrige
*/
ImageMono* debruitageTikhonov(ImageMono& source, int nbiter, double alpha, double dt);
/*
 Function: debruitageHypersurface
  Permet une restauration par la mthode des hypersurfaces (le plus performant)

  Paramtres:
    source - l'image source (non vide)
    nbiter - le nombre d'itration  effectuer
    alpha - valeurs paramtrables
    dt - discrtisation temporelle

 Retour:
   Un pointeur sur l'image corrige
*/
ImageMono* debruitageHypersurface(ImageMono& source, int nbiter, double alpha, double dt);

/*
 Function: debruitageVariation
  Permet une restauration par la mthode de la variation totale

  Paramtres:
    source - l'image source (non vide)
    nbiter - le nombre d'itration  effectuer
    alpha - valeurs paramtrables
    dt - discrtisation temporelle

 Retour:
   Un pointeur sur l'image corrige
*/
ImageMono* debruitageVariation(ImageMono& source, int nbiter, double alpha, double dt);

#endif
