#ifndef IMAGE_MONO_H
#define IMAGE_MONO_H

/***********************************************
 * Code source du cours sur le dbruitage aux quations aux drives partielles
 *
 * Auteur : HUMBERT Florent
 */


/*
 Title: Module image mono couleur
*/

typedef double ImageMonoType;

/*
 class: ImageMono
   type abstrait de donne permettant la gestion des images mono couleurs
 */
class ImageMono
{
 private:
  int largeur;
  int hauteur;
  ImageMonoType * matrice;

 public:
  /*
   Constructor: ImageMono
     Crait une image vide (sans taille pralable), utile pour l'utiliser en temps que pointeur
   */
  ImageMono();

  /*
   Constructor: ImageMono
    Paramtres:
     largeur - largeur de l'image
     hauteur - hauteur de l'image
  */
  ImageMono(int largeur, int hauteur);

  /*
    Method: Hauteur
    Rcupre la hauteur
  */
  int Hauteur();

  /*
    Method: Largeur
    Rcupre la largeur de l'image
  */
  int Largeur();

  /*
    Method: operator() (int x, int y)
     Paramtres:
       x - position verticale o l'on souhaute lire (entre 0 et largeur-1)
       y - position horizontale (entre 0 et hauteur-1)
     Retour:
      Le pixel  cette positition
    */
  ImageMonoType operator() (int x, int y) const;

  ImageMonoType& operator() (int x, int y);

  //ImageMono& operator=(const ImageMono& source);

  /*destroyer*/
 ~ImageMono();

 /*
   Method: Clone
   Permet de cloner une image, retourne un pointeur
   */
  ImageMono& Clone();

  /*
    Method: Copie
    Copie une image dans une image dj initialie

    Paramtres:
      dest - image de desintation

    Prconditions:
      dest doit tre de mme taille que this
  */
  void Copie(ImageMono* dest);

 /*
  Method: ChargerPPM
   Charge un fichier PGM noir et blanc

   Paramtres:
    c - le lien du fichier
   Prconditions:
    Le fichier doit tre de couleur noir et blanc ASCII avec comme borne de couleurs : 256
   */
  void ChargerPPM(char* c);

  /*
   Method: SauvegarderPPM
      Sauvegarde un fichier PGM noir et blanc

    Paramtres:
     c - le lien
  */
  void SauvegarderPPM(char* c);

 //oprateur diffrentiel

  /* Methods: Dx, Dy, Dxx, Dyy, Dxy, Dnn, Dntnt
    Calcule les drives partielles correspondant au position x y
  */
  ImageMonoType Dx(int x, int y);
  ImageMonoType Dy(int x, int y);
  ImageMonoType Dxx(int x, int y);
  ImageMonoType Dyy(int x, int y);
  ImageMonoType Dxy(int x, int y);
  ImageMonoType Dnn(int x, int y);
  ImageMonoType Dntnt(int x, int y);
  ImageMonoType NGrad(int x, int y);
  ImageMonoType NGradCarre(int x, int y);

};
ImageMonoType min(ImageMonoType a, ImageMonoType b);
ImageMonoType max(ImageMonoType a, ImageMonoType b);


#endif
